#include <stdio.h>
#include <windows.h>
#include "bitmapReader.h"

typedef struct tagBITMAPFILEHEADER {
        WORD    bfType;
        DWORD   bfSize;
        WORD    bfReserved1;
        WORD    bfReserved2;
        DWORD   bfOffBits;
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
        DWORD      biSize;
        LONG       biWidth;
        LONG       biHeight;
        WORD       biPlanes;
        WORD       biBitCount;
        DWORD      biCompression;
        DWORD      biSizeImage;
        LONG       biXPelsPerMeter;
        LONG       biYPelsPerMeter;
        DWORD      biClrUsed;
        DWORD      biClrImportant;
} BITMAPINFOHEADER;



bool genericLoadBitmapFile24(char* fileName, BitmapImage& bitmapImage)
{
	FILE *filePtr; //our file pointer
	bool stop=true;
	int temp;
	
	BITMAPINFO bitmapInfo;
	
	
	BITMAPFILEHEADER bitmapFileHeader; //our bitmap file header
	//RGBQUAD* result;
	//int imageIdx=0; //image index counter
	//unsigned char tempRGB; //our swap variable

	//open filename in read binary mode
	if ((filePtr = fopen(fileName,"rb"))==NULL)
	{
		return false;
	}

	//read the bitmap file header
	fread(&bitmapFileHeader, sizeof(BITMAPFILEHEADER), 1,filePtr);

	//verify that this is a bmp file by check bitmap id
	if (bitmapFileHeader.bfType !=0x4D42)
	{
		fclose(filePtr);
		return false;
	}

	//read the bitmap info header
	fread(&bitmapInfo.bmiHeader, sizeof(BITMAPINFOHEADER),1,filePtr);

	//printf("the  sizeof(BITMAPINFOHEADER) is %d\n",  sizeof(BITMAPINFOHEADER));
	//printf(" and  sizeof(BITMAPFILEHEADER) is %d\n", sizeof(BITMAPFILEHEADER));

	//move file point to the begging of bitmap data
	//fseek(filePtr, bitmapFileHeader.bfOffBits, SEEK_SET);
	//printf("bits offset is %d\n", bitmapFileHeader.bfOffBits);

	//allocate enough memory for the bitmap image data
	//bitmapImage = new unsigned char[pBitmapInfo->bmiHeader.biSizeImage];

	switch (bitmapInfo.bmiHeader.biBitCount)
	{
	case 0:
		printf("rgb\n");

		break;
	case 1:
		printf("monochrome\n");

		break;
	case 4:
		printf("16 color\n");
		break;

	case 8:
		printf("256 color\n");
		

		break;
	case 16:
		printf("16bit \n");
		break;
	case 24:
		printf("24bit\n");
		stop=false;
		break;
	case 32:
		printf("32bit\n");

		break;
	}
	//printf("height=%d, width=%d\n", bitmapInfo.bmiHeader.biHeight, 
	//	bitmapInfo.bmiHeader.biWidth);
	//pBitmapInfo->bmiColors=new 
		//RGBQUAD[pBitmapInfo->bmiHeader.biWidth*pBitmapInfo->bmiHeader.biHeight];
	//printf("color used %d\n", bitmapInfo.bmiHeader.biClrUsed);
	//printf("image size %d\n", bitmapInfo.bmiHeader.biSizeImage);
	if (bitmapInfo.bmiHeader.biClrUsed==0)
	{
		bitmapInfo.bmiHeader.biClrUsed=1<<bitmapInfo.bmiHeader.biBitCount;
	}
	//printf("so, color used should be %d\n", bitmapInfo.bmiHeader.biClrUsed);

	//printf("file size is %d and minus offset is %d\n", bitmapFileHeader.bfSize, 
	//	bitmapFileHeader.bfSize-bitmapFileHeader.bfOffBits);

	if (stop)
	{
		return false;
	}
	stop=true;
	switch (bitmapInfo.bmiHeader.biCompression)
	{
	case BI_RGB:
		printf("BI_RGB\n");
		stop=false;
		break;
	case BI_RLE8:
		printf("BI_RLE8\n");
		break;

	case BI_RLE4:
		printf("BI_RLE4\n");

		break;

	case BI_BITFIELDS:

		printf("BI_BITFIELDS\n");

		break;

	//case BI_JPEG:
	//	printf("BI_JPEG\n");

	//	break;
	}
	//printf("now I am %d\n", ftell(filePtr));
	//printf("I need to read from %d\n", bitmapFileHeader.bfOffBits);

	fseek(filePtr, bitmapFileHeader.bfOffBits , SEEK_SET);
	int paddedWidth;
	paddedWidth=(bitmapInfo.bmiHeader.biWidth*3+3)/4*4;
	//paddedWidth=bmp->bitmapInfo.bmiHeader.biWidth*3;
	bitmapImage.image=new unsigned char[paddedWidth*bitmapInfo.bmiHeader.biHeight];
	
	if ((temp=fread(bitmapImage.image, paddedWidth*bitmapInfo.bmiHeader.biHeight, 1, filePtr))
		!=paddedWidth*bitmapInfo.bmiHeader.biHeight)
	{
		if (!feof(filePtr))
		{
			printf("reading error\n");
		}
		else
		{
			printf("unexpected eof\n");
		}
	}
	//printf("read=%d and size=%d\n", temp, paddedWidth*bitmapInfo.bmiHeader.biHeight);
	//printf("error %d\n", GetLastError());

	bitmapImage.width=bitmapInfo.bmiHeader.biWidth;
	bitmapImage.height=bitmapInfo.bmiHeader.biHeight;
	
	fclose(filePtr);
	return true;
}
