
/*************************************************************************************
file name: displayer.h
author: qingzhe huang
date: Nov. 19, 2007
This is a combination of "Master" and "Displayer" module which maybe needs to be separated
in other situation. i.e. It runs a too heavy job as a role of two.

*************************************************************************************/
#pragma once

#include "config.h"
#include "dataStructure.h"
#include "renderEngine.h"

using namespace std;

struct DisplayerContext
{
	static char* windowTitle;
	int renderPixelCount[RenderCount+1];
	ubyte* renderPixelPtr[RenderCount];

	ubyte* colorBuffer;
	ubyte* pixelDataBuffer;
	ubyte* visibleTable;
	//////////////////////////////////////
	//use this as receiving buffer for compressed visible table
	ubyte* compressedVisibleTable;
	////////////////////////////////////

	MPI_Request* visibleTableRequests;
	MPI_Request* pixelDataRequests;
	MPI_Request* colorBufferRequests;
	
	MPI_Request naiveVisibleTableRequest;

	void init();
	void keyboardCallback(unsigned char key, int x, int y);

	void displayCallback();

	void recvVisiblePixelInfo();
	void testVisiblePixelInfoRecving();

	void displayerPrepareRecvPixelData();	
	void recvPixelData();
	void testPixelDataRecving();

	void recvColorBuffer();
	void testColorBufferRecving();
	void outputColorBuffer();
};

static DisplayerContext displayerContext;


