#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* HomePath="/nfs/home/q/qingz_hu";

const unsigned int MaxNodeNumber=32;
const unsigned int MaxTesterChoice=4;
const unsigned int MaxRenderChoice=28;
const unsigned int MaxScriptNumber=MaxTesterChoice*MaxRenderChoice;
const unsigned int MinTesterChoice=2;
const unsigned int MinRenderChoice=1;

const unsigned int TermNumber=6;
const unsigned int TesterChoice[MaxTesterChoice]=
{
	2,4,8,16
};

enum TermEnum
{
	MI=0, RS=1, RC=2, TS=3, TC=4, DI=5
};

const char* TermName[TermNumber]=
{
	"MasterIndex",   //MI
	"RenderHostStartIndex",  //RS
	"RenderCount",           //RC
	"TesterHostStartIndex",
	"TesterCount",
	"DisplayerIndex"
};
void generateScriptFiles(FILE* runStream, int expand);

void generateExpandList()
{
	FILE*runStream;
	if ((runStream=fopen("myRunList.sh", "w"))==NULL)
	{
		printf("cannot create run list file\n");
		exit(25);
	}
	fprintf(runStream, "#!/bin/tcsh\n");
	for (int i=1; i<7; i++)
	{
		fprintf(runStream, "cd %s/running/profileData\n", HomePath);
		fprintf(runStream, "rm -fR %s/running/profileData/expand%u\n", HomePath, i);

		fprintf(runStream, "cd %s/run%u/\n", HomePath, i);
		fprintf(runStream, "rm -fR ./profile\n");
		fprintf(runStream, "rm -fR ./result\n");
		fprintf(runStream, "rm -fR ./data\n");
		
		fprintf(runStream, "mkdir profile\n");
		fprintf(runStream, "mkdir result\n");
		fprintf(runStream, "mkdir data\n");
		generateScriptFiles(runStream, i);
		fprintf(runStream, "mv %s/run%u/data  %s/running/profileData/expand%u/\n", HomePath, i, HomePath, i);
		fprintf(runStream, "mv %s/run%u/result  %s/running/profileData/expand%u/\n", HomePath, i, HomePath, i);
		fprintf(runStream, "mv %s/run%u/profile  %s/running/profileData/expand%u/\n", HomePath, i, HomePath, i);
	}
	fclose(runStream);
}		

void generateScriptFiles(FILE* runStream, int expand)
{
	FILE* stream;
	char fileName[32];
	char buffer[256];
	int i;
	unsigned int configNumber[TermNumber];

	for (int t=0; t<MaxTesterChoice; t++)
	{
		for (int r=0; r<MaxRenderChoice; r++)
		{
			configNumber[TS]=0;
			configNumber[TC]=TesterChoice[t];
			configNumber[RS]=configNumber[TC];
			configNumber[RC]=MinRenderChoice+r;
			configNumber[MI]=configNumber[TC]+configNumber[RC];
			configNumber[DI]=configNumber[MI]+1;
			if (configNumber[TC]+configNumber[RC]>=31)
			{
				continue;
			}
			sprintf(buffer, "T%uR%u", configNumber[TC], configNumber[RC]);
			sprintf(fileName, "%s/run%u/%s.sh", HomePath, expand, buffer);
			fprintf(runStream, "chmod u+x %s\n", fileName);
			fprintf(runStream, "%s\n", fileName);
			//delete script immediately
			fprintf(runStream, "rm -f %s\n", fileName);
	
			//write exec script
			if ((stream=fopen(fileName, "w"))==NULL)
			{
				printf("cannot create file %s\n", fileName);
			}
			
			fprintf(stream, "#!/bin/tcsh\n");
			fprintf(stream, "cd %s/run%u/\n", HomePath, expand);
			fprintf(stream, "./replace.exe ");
			for (i=0; i<TermNumber; i++)
			{
				fprintf(stream, " %u", configNumber[i]);
			}
			fprintf(stream, "\n");
			fprintf(stream, "module load mpi\n");
			fprintf(stream, "cd %s/octree/octree/\n", HomePath);
			
			fprintf(stream, "./go.bat\n");
			fprintf(stream, "cd /nfs/home/q/qingz_hu/run%u/\n", expand);
			fprintf(stream, "rm -f *.txt\n");
			fprintf(stream, "mpirun -srun -N %u --nodelist=n120", configNumber[TC]+configNumber[RC]+2); 		
			for (i=0; i<configNumber[TC]+configNumber[RC]+1; i++)
			{
				fprintf(stream, ",n%u", 119-i);
			}
			fprintf(stream, " ./renderBox.exe>./result/%s.txt\n", buffer);
			fprintf(stream, "mkdir ./data/%s\n", buffer);
			fprintf(stream, "mv *.txt ./data/%s\n", buffer);
			fprintf(stream, "./sumTool.exe ./data/%s > ./profile/%s.txt\n", buffer, buffer);
			/////////////////////////
			//clear up
			

			fclose(stream);

		}
	}
}			    
				
			
/*			
void clearScript(char* fileName)
{
	FILE* stream;
	char buffer[256];
	if ((stream=fopen(fileName, "w"))==NULL)
	{
		printf("cannot create file %s\n", fileName);
		exit(34);
	}
	fprintf(stream, "#!/bin/tcsh\n");
	strcpy(buffer, path);
	for (int i=0; i<6; i++)
	{
		fprintf(stream, "mv %s/run%u/data  %s/running/profileData/expand%u\n", path, i, path, i);
		fprintf(stream, "mv %s/run%u/result  %s/running/profileData/expand%u\n", path, i, path, i);
		fprintf(stream, "mv %s/run%u/profile  %s/running/profileData/expand%u\n", path, i, path, i);
	}
	fclose(stream);
}
*/	
	




int main(int argc, char** argv)
{
	generateExpandList();
	return 0;
}
