#ifndef _FRUSTUM_H
#define _FRUSTUM_H

#include "plyModel.h"

// This will allow us to create an object to keep track of our frustum
class CFrustum {

public:

	bool cohenSutherland(unsigned char first, unsigned char second);
	bool pointInsideFrustum(VType coord[3], unsigned char& codess);
	bool canCullCube(VType center[3], VType halfWidth);
	// Call this every time the camera moves to update the frustum
	void CalculateFrustum();

	// This takes a 3D point and returns TRUE if it's inside of the frustum
	bool PointInFrustum(VType x, VType y, VType z);

	// This takes a 3D point and a radius and returns TRUE if the sphere is inside of the frustum
	bool SphereInFrustum(VType x, VType y, VType z, VType radius);

	// This takes the center and half the length of the cube.
	int CubeInFrustum( VType x, VType y, VType z, VType size );

	int cubeInsideFrustum(VType x, VType y, VType z, VType size );

	bool canCullCube(VType x, VType y, VType z, VType halfWidth);

private:

	// This holds the A B C and D values for each side of our frustum.
	VType m_Frustum[6][4];
};

#endif //_FRUSTUM_H 

// 
// Ben Humphrey (DigiBen)
// Game Programmer
// DigiBen@GameTutorials.com
// Co-Web Host of www.GameTutorials.com
//
