renderBox.exe: frustum.obj octree.obj octreeLoader.obj renderEngine.obj viewCollector.obj syscallLinux.obj master.obj tester.obj render.obj \
        dataStructure.obj displayer.obj occluder.obj renderBox.cpp
	@echo "compiling renderBox.exe..."
	mpiCC -g -lGL -lGLU -lglut -lmpi frustum.obj octree.obj octreeLoader.obj renderEngine.obj viewCollector.obj syscallLinux.obj master.obj \
        tester.obj render.obj dataStructure.obj occluder.obj renderBox.cpp displayer.obj  -o ./bin/renderBox.exe 
	rm -f *.obj
syscallLinux.obj: syscall.h syscallLinux.cpp
	@echo "syscallLinux.obj"
	mpiCC -g -c syscallLinux.cpp -o syscallLinux.obj

displayer.obj: syscall.h config.h displayer.cpp displayer.h
	@echo "displayer.obj"
	mpiCC -g -c displayer.cpp -o displayer.obj

frustum.obj: frustum.cpp frustum.h config.h
	@echo "frustum.obj..."
	mpiCC -g -c frustum.cpp -o frustum.obj
octree.obj: octree.h octree.cpp syscall.h config.h
	@echo "octree.obj..."
	mpiCC -g -c octree.cpp -o octree.obj
octreeLoader.obj: octreeLoader.cpp octreeLoader.h frustum.obj
	@echo "octreeLoader.obj ..."
	mpiCC -g -c octreeLoader.cpp -o octreeLoader.obj

viewCollector.obj: viewCollector.h viewCollector.cpp octreeLoader.obj octreeLoader.h
	@echo "viewCollector.obj..."
	mpiCC -g -c viewCollector.cpp  -o viewCollector.obj
renderEngine.obj: renderEngine.cpp renderEngine.h 
	@echo "renderEngine.obj..."
	mpiCC -g -c renderEngine.cpp -o renderEngine.obj
master.obj: master.h master.cpp config.h
	@echo "master.obj..."
	mpiCC -g -c master.cpp -o master.obj
tester.obj: tester.cpp tester.h config.h
	@echo "tester.obj..."
	mpiCC -g -c tester.cpp -o tester.obj
render.obj: render.h render.cpp config.h
	@echo "render.obj..."
	mpiCC -g -c render.cpp -o render.obj
dataStructure.obj: dataStructure.cpp dataStructure.h config.h
	@echo "dataStructure.obj..."
	mpiCC -g -c dataStructure.cpp -o dataStructure.obj

occluder.obj: occluder.h occluder.cpp
	@echo "occluder.obj..."
	mpiCC -g -c occluder.cpp -o occluder.obj

	
