///////////////////////////////////////////////////////////////
//The molton code scheme is as simple as following:
//1. using an unsigned int (32) for code.
//2. The first 4 bits represents level, , root node starting from 0x0 (this limits our deepest level from 16
//3. each level using 3 bits representing son index.
// I forget this after only two weeks
//
////////////////////////////////////////////////////////////////
////we use the largest radius for radius of octree node
//
//////////////////////////////////////////////////////////////

#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <algorithm>
#include "octree.h"


#ifndef LINUX_VERSION
#include <windows.h>
#include <winbase.h>
#include "except.h"
const char* DataFilePath=".\\";
#else
const char* DataFilePath="./";
//const char* DataFilePath="/sfs/nobackup/all/qingz_hu/octree/single/expand1/";
#endif
//////////////////////////////////////////////

//application programmer is responsible to change this path to its application path
//const char* DataFilePath="/sfs/backup/all/qingz_hu/octree/bin/single/bin";


const char* VertexFileName="vertex.data";
const char* FaceFileName="face.data";
const char* FakeColorFileName="fakeColor.data";
const char* InfoFileName="info.data";
const char* OctreeFileName="octree.data";


//////////////////////////////////////////////////////////

char InfoStruct::vertexFileName[MAX_PATH];
char InfoStruct::faceFileName[MAX_PATH];
char InfoStruct::fakeColorFileName[MAX_PATH];
char InfoStruct::infoFileName[MAX_PATH];
char InfoStruct::octreeFileName[MAX_PATH];


Octree* Octree::root=NULL;

//////////////////////////////////////////////////////////
HANDLE Octree::vertexHandle=INVALID_HANDLE_VALUE;
HANDLE Octree::faceHandle=INVALID_HANDLE_VALUE;
HANDLE Octree::octreeHandle=INVALID_HANDLE_VALUE;
HANDLE Octree::infoHandle=INVALID_HANDLE_VALUE;
HANDLE Octree::vertexMapHandle=NULL;
HANDLE Octree::faceMapHandle=NULL;

InfoStruct Octree::infoStruct;

VType Octree::operations[8][3]=
{
	{-1,-1,1},//0
	{-1,-1,-1},//1
	{-1, 1,1},//2
	{-1,1,-1},//3
	{1,-1,-1},//5
	{1,-1,1},//4
	{1,1,-1},//7
	{1,1,1},//6
};


void sortTriangleIndex(unsigned int triangle[3])
{
	int swap;
	if (triangle[0]>triangle[1])
	{
		swap=triangle[0];
		triangle[0]=triangle[1];
		triangle[1]=swap;
	}
	if (triangle[0]>triangle[2])
	{
		swap=triangle[0];
		triangle[0]=triangle[2];
		triangle[2]=swap;
	}
	if (triangle[1]>triangle[2])
	{
		swap=triangle[1];
		triangle[1]=triangle[2];
		triangle[2]=swap;
	}
}


InfoStruct::InfoStruct()
{
#ifdef LINUX_VERSION
	char delimiter='/';
#else
	char delimiter='\\';
#endif

	int length=strlen(DataFilePath);
	strcpy(vertexFileName, DataFilePath);
	strcpy(faceFileName, DataFilePath);
	strcpy(fakeColorFileName, DataFilePath);
	strcpy(infoFileName, DataFilePath);
	strcpy(octreeFileName, DataFilePath);

	if (DataFilePath[length-1]!=delimiter)
	{
		vertexFileName[length]=delimiter;
		faceFileName[length]=delimiter;
		fakeColorFileName[length]=delimiter;
		infoFileName[length]=delimiter;
		octreeFileName[length]=delimiter;	


		vertexFileName[length+1]='\0';
		faceFileName[length+1]='\0';
		fakeColorFileName[length+1]='\0';
		infoFileName[length+1]='\0';
		octreeFileName[length+1]='\0';
	}

	strcat(vertexFileName, VertexFileName);
	strcat(faceFileName, FaceFileName);
	strcat(fakeColorFileName, FakeColorFileName);
	strcat(infoFileName, InfoFileName);
	strcat(octreeFileName, OctreeFileName);
}

void InfoStruct::display()
{

	printf("general configure information:\n");

	printf("node size: %d, max leaf node vertex number: %d\n", nodeSize, maxLeafNodeVertexNumber);

	printf("\n*************information for this particular octree*************\n");
	printf("node count: %d, leafNodeNumber:%d, max depth: %d\n", nodeCount, leafNodeNumber, maxDepth);
	printf("totalVPageCount: %d, totalFPageCount: %d\n", totalVPageCount, totalFPageCount);

	printf("max edge: %f, min edge: %f \n", maxEdge, minEdge);

	printf("max x=%f, min x=%f, max z=%f min z=%f\n", maxX, minX, maxZ, minZ);
	

	printf("origin[%f,%f,%f]\n", origin[0], origin[1], origin[2]);

	printf("total repeat vertex: %d, total repeat face: %d\n", totalRepeatVertex, totalRepeatFace);

	printf("total neighbour count: %d\n", totalNeighbourCount);
	printf("total vertex number:%d, total face number:%d\n", totalVertex, totalFace);
	printf("file path %s\n", DataFilePath);

}


void InfoStruct::display(FILE* stream)
{
	fprintf(stream, "general configure information:\n");

	fprintf(stream, "node size: %d, max leaf node vertex number: %d\n", nodeSize, maxLeafNodeVertexNumber);

	fprintf(stream, "information for this particular octree:\n");
	fprintf(stream, "node count: %d, leafNodeNumber:%d, max depth: %d\n", nodeCount, leafNodeNumber, maxDepth);
	fprintf(stream, "totalVPageCount: %d, totalFPageCount: %d\n", totalVPageCount, totalFPageCount);

	fprintf(stream, "max edge: %f, min edge: %f\n", maxEdge, minEdge);

	fprintf(stream, "origin[%f,%f,%f]\n", origin[0], origin[1], origin[2]);

	fprintf(stream, "total repeat vertex: %d, total repeat face: %d\n", totalRepeatVertex, totalRepeatFace);

	fprintf(stream, "total neighbour count: %d\n", totalNeighbourCount);
	fprintf(stream, "total vertex number:%d, total face number:%d\n", totalVertex, totalFace);
	fprintf(stream, "file path %s\n", DataFilePath);
}

void Octree::display()
{
	printf("vNumber[%d],vRepeatNumber[%u], vFileAddLow[%u], vFileAddHigh[%u], vMapSize[%u],\
		vStartPageIndex[%u], vPageCount[%u]\n", 
		vNumber, vRepeatNumber, vFileAddLow, vFileAddHigh, vMapSize, vStartPageIndex,
		vPageCount );
}

void Octree::readInfo(bool readOnly)
{
	int length;

	infoHandle=GenericOpenFile(InfoStruct::infoFileName, readOnly);
	length=GenericReadFile(infoHandle, &infoStruct, sizeof(InfoStruct));


	if (length==0)
	{
		//this must be the very first 
		infoStruct.totalFPageCount=infoStruct.totalVPageCount=0;
		infoStruct.leafNodeNumber=infoStruct.totalNeighbourCount=0;
		infoStruct.totalRepeatFace=infoStruct.totalRepeatVertex=0;
		infoStruct.maxDepth=infoStruct.nodeCount=0;
		infoStruct.minEdge=infoStruct.maxEdge=0.0;
		
		infoStruct.nodeSize=sizeof(Octree);
		memset(infoStruct.origin, 0, sizeof(VVector));
		infoStruct.maxNodeArrayLength=NodeArrayLengthIncrement;
		infoStruct.maxLeafNodeVertexNumber=DefaultMaxLeafNodeVertexNumber;
	}
	else
	{
		if (length!=sizeof(InfoStruct))
		{
			printf("read info file error\n");
			exit(1234);
		}
		//infoStruct.display();
	}

}



void Octree::initialize(bool readOnly, bool useFake)
{

/*
	unsigned long int length;
	DWORD accessRight;

	if (readOnly)
	{
		accessRight=GENERIC_READ;
	}
	else
	{
		accessRight=GENERIC_READ|GENERIC_WRITE;
	}

	if ((infoHandle=CreateFile(InfoStruct::infoFileName, accessRight, FILE_SHARE_READ, NULL, 
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))==INVALID_HANDLE_VALUE)
	{
		printf("open info file failed\n");
		exit(123);
	}
	if (ReadFile(infoHandle, &infoStruct, sizeof(InfoStruct), &length, NULL)==FALSE)
	{
		printf("read info file failed\n");
		exit(1234);
	}
*/
  
	readInfo(readOnly);
	//now let's open all files

	/*
	vertexHandle=CreateFile(InfoStruct::vertexFileName, accessRight, 
		FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL , NULL);
	faceHandle=CreateFile(InfoStruct::faceFileName, accessRight, FILE_SHARE_READ, 
		NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	octreeHandle=CreateFile(InfoStruct::octreeFileName, accessRight,
		FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	if (vertexHandle==INVALID_HANDLE_VALUE||faceHandle==INVALID_HANDLE_VALUE
		||octreeHandle==INVALID_HANDLE_VALUE)
	{
		printf("open data file failed\n");
		exit(12);
	}
	*/
	if (useFake)
	{
		vertexHandle=GenericOpenFile(InfoStruct::fakeColorFileName, readOnly);
	}
	else
	{
		vertexHandle=GenericOpenFile(InfoStruct::vertexFileName, readOnly);
	}
	faceHandle=GenericOpenFile(InfoStruct::faceFileName, readOnly);
	vertexMapHandle=GenericCreateFileMapping(vertexHandle, readOnly);
	faceMapHandle=GenericCreateFileMapping(faceHandle, readOnly);
	octreeHandle=GenericOpenFile(InfoStruct::octreeFileName, readOnly);

	root=new Octree[infoStruct.maxNodeArrayLength];
	CHECK_NEW(root);

	
	/*
	if (ReadFile(octreeHandle, root, sizeof(Octree)*infoStruct.nodeCount, &length, NULL)==FALSE)
	{
		printf("read octree data failed\n");
		exit(78);
	}
	if (length!=sizeof(Octree)*infoStruct.nodeCount)
	{
		printf("read octree data error\n");
		exit(9);
	}
	*/
	GenericReadFile(octreeHandle, root, sizeof(Octree)*infoStruct.nodeCount);
}


void Octree::uninitialize(bool readOnly)
{
	if (!readOnly)
	{
		GenericSetFilePointer(infoHandle, 0, 0);
		GenericWriteFile(infoHandle,  &infoStruct, sizeof(InfoStruct));
		GenericSetFilePointer(octreeHandle, 0, 0);
		GenericWriteFile(octreeHandle, root, sizeof(Octree)*infoStruct.nodeCount);
	}
	delete[] root;
	GenericCloseFile(infoHandle);
	GenericCloseFile(octreeHandle);
	GenericCloseFile(vertexHandle);
	GenericCloseFile(faceHandle);
	/*
	unsigned long int length;
	if (!readOnly)
	{
		if (SetFilePointer(infoHandle, 0, NULL, FILE_BEGIN)==0xFFFFFFFF)
		{
			printf("set file pointer failed\n");
			exit(1234);
		}
		if (WriteFile(infoHandle, &infoStruct, sizeof(InfoStruct), &length, NULL)==FALSE)
		{
			printf("write info file failed\n");
			exit(123);
		}
		if (SetFilePointer(octreeHandle, 0, NULL, FILE_BEGIN)==0xFFFFFFFF)
		{
			printf("set file pointer failed\n");
			exit(345);
		}
		if (WriteFile(octreeHandle, root, sizeof(Octree)*infoStruct.nodeCount, &length, NULL)==FALSE)
		{
			printf("write octree file failed\n");
			exit(234);
		}
	}
	delete[] root;
	CloseHandle(infoHandle);
	CloseHandle(octreeHandle);
	CloseHandle(vertexHandle);
	CloseHandle(faceHandle);
	*/
}

//return the new node index
int Octree::createNewOctreeNode(int myOwnIndex, int nodePos)
{
	//Octree *ptr;
	Octree* newRoot;
	int result;
	//lazy
	//ptr=root+nodeCount;
	//parent

	if (root[myOwnIndex].sons[nodePos]!=-1)
	{
		return root[myOwnIndex].sons[nodePos];
	}

	result=infoStruct.nodeCount;
	initOctreeNode(result);

	root[myOwnIndex].sonCount++;
	root[myOwnIndex].sons[nodePos]=result;

	setSonNodeCentre(myOwnIndex, result, nodePos);
	////////////////////////////////
	//son
	root[result].width=root[myOwnIndex].width/2.0;
	root[result].myNodeIndex=result;//this will not change
	root[result].level=root[myOwnIndex].level+1;
	root[result].parentIndex=root[myOwnIndex].myNodeIndex;

	if (root[result].level>infoStruct.maxDepth)
	{
		infoStruct.maxDepth=root[result].level;
		if (infoStruct.maxDepth>MaxPossibleDepth)
		{
			printf("oh my god! The depth is %d\n", infoStruct.maxDepth);		
		}
	}

	infoStruct.nodeCount++;

	//beyond this line, all are safe because we haven't moved octree array yet.
	//do we have any recursion call problem???
	if (infoStruct.nodeCount==infoStruct.maxNodeArrayLength)//even this line is safe
	{
		//printf("max node array length reached!\n");
		//exit(78);

		infoStruct.maxNodeArrayLength+=NodeArrayLengthIncrement;
		newRoot=new Octree[infoStruct.maxNodeArrayLength];
		if (newRoot==NULL)
		{
			printf("allocate new octree node array failed\n");
			exit(1);
		}
		memcpy(newRoot, root, sizeof(Octree)*infoStruct.nodeCount);
		memset(root, 0, sizeof(Octree)*infoStruct.nodeCount);//for safety testing
		delete[] root;
		root=newRoot;		
	}
	//this is dangerous because "root" has just changed and "this" is also changed
	return 	result;
}
		

/////////////////////////////////////////


void Octree::setSonNodeCentre(int parentIndex, int sonIndex, int nodeID)
{
	for (int i=0; i<3; i++)
	{
		root[sonIndex].center[i]=root[parentIndex].center[i]+
			operations[nodeID][i]*root[parentIndex].width/4.0;
	}
}


int Octree::relativePosition(VVector vPoint, VVector vCtr)
{
	if( (vPoint[0] <= vCtr[0]) && (vPoint[1] >= vCtr[1]) && (vPoint[2] >= vCtr[2]) )
	{
		return TOP_LEFT_FRONT;
	}

	if( (vPoint[0] <= vCtr[0]) && (vPoint[1] >= vCtr[1]) && (vPoint[2] <= vCtr[2]) )
	{
		return TOP_LEFT_BACK;
	}
	if( (vPoint[0] >= vCtr[0]) && (vPoint[1] >= vCtr[1]) && (vPoint[2] <= vCtr[2]) )
	{
		return TOP_RIGHT_BACK;
	}

	if( (vPoint[0] >= vCtr[0]) && (vPoint[1] >= vCtr[1]) && (vPoint[2] >= vCtr[2]) )
	{
		return TOP_RIGHT_FRONT;
	}
	if( (vPoint[0] <= vCtr[0]) && (vPoint[1] <= vCtr[1]) && (vPoint[2] >= vCtr[2]) )
	{
		return BOTTOM_LEFT_FRONT;
	}

	if( (vPoint[0] <= vCtr[0]) && (vPoint[1] <= vCtr[1]) && (vPoint[2] <= vCtr[2]) )
	{
		return BOTTOM_LEFT_BACK;
	}

	if( (vPoint[0] >= vCtr[0]) && (vPoint[1] <= vCtr[1]) && (vPoint[2] <= vCtr[2]) )
	{
		return BOTTOM_RIGHT_BACK;
	}

	if( (vPoint[0] >= vCtr[0]) && (vPoint[1] <= vCtr[1]) && (vPoint[2] >= vCtr[2]) ) 
	{
		return BOTTOM_RIGHT_FRONT;
	} 
	//we should never reach this
	printf("relative position error\n");
	exit(234);
	return -1;
}


void Octree::doCalculateNeighbour(int nodeIndex, int neighbourIndex)
{
	int i;
	VType distance;
	if (nodeIndex==neighbourIndex)
	{
		return;
	}
	if (root[neighbourIndex].level<root[nodeIndex].level)
	{
		for (i=0; i<8; i++)
		{
			if (root[neighbourIndex].sons[i]!=-1)
			{				
				doCalculateNeighbour(nodeIndex, root[neighbourIndex].sons[i]);
			}
		}
	}
	else
	{
		if (root[nodeIndex].level==root[neighbourIndex].level)
		{
			//check all sides to see if they colinear			
			for (i=0; i<3; i++)
			{
				//all coord must be exact one width away or colinear 
				distance=fabs(root[nodeIndex].center[i]-root[neighbourIndex].center[i]);
				if (distance>Epsilon)
				{			
					distance=fabs(distance-root[nodeIndex].width);
					if (distance>Epsilon)
					{
						//no! this is far away
						return;
					}
				}
			}
			//got it
			root[nodeIndex].neighbours[root[nodeIndex].neighbourCount]=neighbourIndex;
			root[nodeIndex].neighbourCount++;	
			infoStruct.totalNeighbourCount++;
			if (root[nodeIndex].neighbourCount>MaxNeighbourCount)
			{
				printf("corrupted data or neighbour calculation mistake\n");
				exit(77);
			}
		}	
	}
	//in all case we end
}



void Octree::calculateNeighbour()
{
	infoStruct.leafNodeNumber=infoStruct.totalNeighbourCount=0;
	infoStruct.totalRepeatVertex=infoStruct.totalRepeatFace=0;
	infoStruct.totalFace=infoStruct.totalVertex=0;
	for (int i=0; i<infoStruct.nodeCount; i++)
	{
		root[i].neighbourCount=0;
		doCalculateNeighbour(i, 0);
		if (root[i].sonCount==0)
		{
			infoStruct.leafNodeNumber++;
			infoStruct.totalRepeatVertex+=root[i].vRepeatNumber;
			infoStruct.totalRepeatFace+=root[i].fRepeatNumber;
			infoStruct.totalNeighbourCount+=root[i].neighbourCount;
			infoStruct.totalVertex+=root[i].vNumber+root[i].vRepeatNumber;
			infoStruct.totalFace+=root[i].fNumber+root[i].fRepeatNumber;
		}
	}
}

void Octree::initOctreeNode(int nodeIndex)
{	
	int i;
	root[nodeIndex].width=0.0;
	root[nodeIndex].parentIndex=-1;
	root[nodeIndex].level=-1;
	memset(root[nodeIndex].center, 0, sizeof(VVector));
	//root[nodeIndex].fStartIndex=0;
	root[nodeIndex].fNumber=root[nodeIndex].vNumber
		=root[nodeIndex].vRepeatNumber=root[nodeIndex].fRepeatNumber=0;
	root[nodeIndex].neighbourCount=0;
	for(i=0; i<8; i++)
	{
		root[nodeIndex].sons[i]=-1;
	}
	root[nodeIndex].sonCount=0;
	//hard coding this;
	root[nodeIndex].myNodeIndex=nodeIndex;
	root[nodeIndex].vAddress=root[nodeIndex].fAddress=NULL;
	root[nodeIndex].vFileAddHigh=root[nodeIndex].vFileAddLow
		=root[nodeIndex].fFileAddLow=root[nodeIndex].fFileAddHigh=-1;
	root[nodeIndex].vMapSize=root[nodeIndex].fMapSize=0;
	root[nodeIndex].vPageCount=root[nodeIndex].fPageCount=0;
	root[nodeIndex].vStartPageIndex=root[nodeIndex].fStartPageIndex=-1;

}

//we may need consider the floating point error.
bool Octree::isCoordInsideBox(int nodeIndex, VVector coord)
{

	for (int i=0; i<3; i++)
	{
		if (coord[i]>root[nodeIndex].center[i]+root[nodeIndex].width/2.0||
			coord[i]<root[nodeIndex].center[i]-root[nodeIndex].width/2.0)
		{
			return false;
		}
	}
	return true;
}

//return existed offset if it has, if none find, use the "suggested" 
bool Octree::addVertexInfoToHashTable(HashTableNode* hashTable, int vIndex, int sonPos, 
									  int& offset)
{
	VertexInfo vertexInfo;

	vertexInfo.sonPos=sonPos;
	vertexInfo.offset=offset;
	for (int i=0; i<hashTable[vIndex].size(); i++)
	{
		if (hashTable[vIndex][i].sonPos==sonPos)
		{
			offset=hashTable[vIndex][i].offset;
			return true;
		}
	}
	//no finding
	//error checking, assuming input is initialized to -1 for repeat vertex
	if (offset==-1)
	{
		printf("data corrupted\n");
		exit(234);
	}
	hashTable[vIndex].push_back(vertexInfo);
	return false;//not find it

}

void Octree::calculateFileOffsetV(int startPageIndex, int offset, unsigned long& low, unsigned long& high)
{
	LONGLONG li;
	li=Int32x32To64(startPageIndex, PageSize) + Int32x32To64(offset, sizeof(PlyVertex));
	low=li;
	high=li>>32;
}


void Octree::calculateFileOffsetF(int startPageIndex, int offset, unsigned long& low, unsigned long& high)
{
	LONGLONG li;
	li=Int32x32To64(startPageIndex, PageSize) + Int32x32To64(offset, sizeof(UIVector));
	low=li;
	high=li>>32;
}

void Octree::setFilePointerV(int nodeIndex, int offset)
{
	unsigned long low, high;
	calculateFileOffsetV(root[nodeIndex].vStartPageIndex, offset, low, high);
	/*
	if (SetFilePointer(vertexHandle, low, &high, FILE_BEGIN)==0XFFFFFFFF)
	{
		printf("set file pointer failed %d\n", GetLastError());
		exit(123);
	}
	*/
	GenericSetFilePointer(vertexHandle, low, high);
}

void Octree::setFilePointerF(int nodeIndex, int offset)
{
	unsigned long low, high;
	calculateFileOffsetF(root[nodeIndex].fStartPageIndex, offset, low, high);
	/*
	if (SetFilePointer(faceHandle, low, &high, FILE_BEGIN)==0XFFFFFFFF)
	{
		printf("set file pointer failed %d\n", GetLastError());
		exit(123);
	}
	*/
	GenericSetFilePointer(faceHandle, low, high);
}

bool findCoord(VertexVector& vertexVector, VVector coord)
{
	for (int i=0; i<vertexVector.size(); i++)
	{
		if (equalCoord(vertexVector[i].coord, coord))
		{
			return true;
		}
	}
	return false;
}


#ifdef 	USING_QUICK_RECURSION
void Octree::readOriginalVertex(int nodeIndex, VertexVector& vertexVector, 
				VertexVector& repeatVertexVector, FaceVector& repeatFaceVector)
{
	PlyVertex* plyVertex, *ptr;
	int i, j, originalVertexVectorSize;
	unsigned long int low, high, length;

	calculateFileOffsetV(root[nodeIndex].vStartPageIndex, 0, low, high); 
	
	length=sizeof(PlyVertex)*(root[nodeIndex].vNumber+root[nodeIndex].vRepeatNumber);
	plyVertex=(PlyVertex*)GenericMapViewOfFile(vertexMapHandle, false, high, low, length);
	
	ptr=plyVertex;

	originalVertexVectorSize=vertexVector.size();

	for (i=0; i<root[nodeIndex].vNumber; i++)
	{
		vertexVector.push_back(ptr[i]);
	}

	for (i=0; i<repeatFaceVector.size(); i++)
	{
		for (j=0; j<3; j++)
		{
			if (repeatFaceVector[i][j]>=originalVertexVectorSize)
			{
				repeatFaceVector[i][j]+=root[nodeIndex].vNumber;
			}
		}
	}
	ptr=plyVertex+root[nodeIndex].vNumber;
	for (i=0; i<root[nodeIndex].vRepeatNumber; i++)
	{
		repeatVertexVector.push_back(ptr[i]);
	}
	GenericUnmapViewOfFile(plyVertex, length);

}
#else
void Octree::readOriginalVertex(int nodeIndex, VertexVector& vertexVector, 
				VertexVector& repeatVertexVector, FaceVector& repeatFaceVector)
{
	PlyVertex plyVertex;
	int i, j, originalVertexVectorSize;
	//unsigned long length;

	setFilePointerV(nodeIndex, 0);
	originalVertexVectorSize=vertexVector.size();

	for (i=0; i<root[nodeIndex].vNumber; i++)
	{
		GenericReadFile(vertexHandle, &plyVertex, sizeof(PlyVertex));
		vertexVector.push_back(plyVertex);
	}

	for (i=0; i<repeatFaceVector.size(); i++)
	{
		for (j=0; j<3; j++)
		{
			if (repeatFaceVector[i][j]>=originalVertexVectorSize)
			{
				repeatFaceVector[i][j]+=root[nodeIndex].vNumber;
			}
		}
	}
	for (i=0; i<root[nodeIndex].vRepeatNumber; i++)
	{
		GenericReadFile(vertexHandle, &plyVertex, sizeof(PlyVertex));
		repeatVertexVector.push_back(plyVertex);
	}

}
#endif

#ifdef USING_QUICK_RECURSION
void Octree::readOriginalFace(int nodeIndex, FaceVector& faceVector, 
			FaceVector& repeatFaceVector, int insertVertexCount, int insertRepeatVertexCount)
{
	FaceStruct* triangle, *ptr;
	int i, j;
	unsigned long int high, low, length;

	calculateFileOffsetF(root[nodeIndex].fStartPageIndex, 0, low, high);

	length=sizeof(FaceStruct)*(root[nodeIndex].fNumber+root[nodeIndex].fRepeatNumber);
	triangle=(FaceStruct*)GenericMapViewOfFile(faceMapHandle, false, high, low, length);
	
	ptr=triangle;

	for (i=0; i<root[nodeIndex].fNumber; i++)
	{
		for (j=0; j<3; j++)
		{
			ptr[i][j]+=insertVertexCount;
		}
		//we need to sort it here so that ...
		sortTriangle(ptr[i]);		
		faceVector.push_back(ptr[i]);	
	}

	ptr=triangle+root[nodeIndex].fNumber;
	for (i=0; i<root[nodeIndex].fRepeatNumber; i++)
	{
		for (j=0; j<3; j++)
		{
			if (ptr[i][j]<root[nodeIndex].vNumber)
			{
				ptr[i][j]+=insertVertexCount;
			}
			else
			{
				ptr[i][j]+=insertVertexCount+insertRepeatVertexCount;
			}
		}
		sortTriangle(ptr[i]);
		////////////////////////////////////
		//test				
		repeatFaceVector.push_back(ptr[i]);
	}
	GenericUnmapViewOfFile(triangle, length);
}
#else
void Octree::readOriginalFace(int nodeIndex, FaceVector& faceVector, 
			FaceVector& repeatFaceVector, int insertVertexCount, int insertRepeatVertexCount)
{
	FaceStruct triangle;
	int i, j;

	setFilePointerF(nodeIndex, 0);
	for (i=0; i<root[nodeIndex].fNumber; i++)
	{
		GenericReadFile(faceHandle, &triangle, sizeof(FaceStruct));
		for (j=0; j<3; j++)
		{
			triangle[j]+=insertVertexCount;
		}
		//we need to sort it here so that ...
		sortTriangle(triangle);		
		faceVector.push_back(triangle);	
	}
	for (i=0; i<root[nodeIndex].fRepeatNumber; i++)
	{
		GenericReadFile(faceHandle, &triangle, sizeof(UIVector));
		for (j=0; j<3; j++)
		{
			if (triangle[j]<root[nodeIndex].vNumber)
			{
				triangle[j]+=insertVertexCount;
			}
			else
			{
				triangle[j]+=insertVertexCount+insertRepeatVertexCount;
			}
		}
		sortTriangle(triangle);
		////////////////////////////////////
		//test				
		repeatFaceVector.push_back(triangle);
	}

}
#endif



//this is exaggerating! How come we have such complicated parameter to pass?
//However, this maybe the "key" function of whole upgrading of project which I try to
//solve after a couple of days thinking
void Octree::addFaceToSonFaceVector(HashTableNode* hashTable, FaceStruct& triangle, 
	VertexVector& vertexVector, VertexVector& repeatVertexVector, 
	VertexVector* sonVertexVector[8], VertexVector* sonRepeatVertexVector[8], 
	FaceVector* sonFaceVector[8], FaceVector* sonRepeatFaceVector[8])
{
	int i, j, sonIndex, suggestIndex;
	FaceStruct result;
	bool isRepeatFace;
	VertexInfo vertexInfo[3];


	//printf("at beginning of function: triangle[%d,%d,%d]\n", triangle[0], triangle[1], triangle[2]);

	//assume triangle is sorted
	for (i=0; i<3; i++)
	{
		if (triangle[i]<vertexVector.size())
		{
			if (hashTable[triangle[i]].size()==0)
			{
				printf("hash table error, triangle[%d,%d,%d]\n", triangle[0], triangle[1], 
					triangle[2]);
				exit(890);
			}
			vertexInfo[i]=hashTable[triangle[i]][0];
		}
		else
		{
			vertexInfo[i].sonPos=-1;
		}
	}

	//now let's see how many differenct choice we have
	if (vertexInfo[0].sonPos==-1)
	{
		printf("hash table error 2, triangle[%d,%d,%d]\n", triangle[0], triangle[1], triangle[2]);
		exit(389);
	}
	
	
	for (i=0; i<3; i++)
	{
		if (vertexInfo[i].sonPos!=-1)
		{
			sonIndex=vertexInfo[i].sonPos;
		}
		else
		{
			continue;
		}
		//still we must make sure it is not repeating
		isRepeatFace=false;
		for (j=0; j<i; j++)
		{
			if (vertexInfo[j].sonPos==sonIndex)
			{
				isRepeatFace=true;
				break;
			}
		}

		if (isRepeatFace)
		{
			continue;
		}
		isRepeatFace=false;
		for (j=0; j<3; j++)
		{
			if (j==i)
			{
				result[j]=vertexInfo[j].offset;
			}
			else
			{
				suggestIndex=sonVertexVector[sonIndex]->size()+
					sonRepeatVertexVector[sonIndex]->size();
				if (vertexInfo[j].sonPos==-1)
				{
					//so it is  a repeated vertex,
					
					if (!addVertexInfoToHashTable(hashTable, triangle[j], sonIndex, suggestIndex))
					{
						sonRepeatVertexVector[sonIndex]->push_back(
							repeatVertexVector[triangle[j]-vertexVector.size()]);
					}
					
				}
				else
				{					
					if (!addVertexInfoToHashTable(hashTable, triangle[j], sonIndex, suggestIndex))
					{
						sonRepeatVertexVector[sonIndex]->push_back(vertexVector[triangle[j]]);						
					}
				}
				if (vertexInfo[j].sonPos!=sonIndex)
				{
					isRepeatFace=true;
				}
				//here it is...
				
				result[j]=suggestIndex;
			}	
		}
		sortTriangle(result);
		//write face
		
		if (isRepeatFace)
		{		
			sonRepeatFaceVector[sonIndex]->push_back(result);
		}
		else
		{
			////////////////////////////////		
			sonFaceVector[sonIndex]->push_back(result);
		}		
	}
}

#ifdef	USING_QUICK_RECURSION
void Octree::doCreateLeafNode(int nodeIndex, VertexVector& vertexVector, 
		VertexVector& repeatVertexVector, FaceVector& faceVector, FaceVector& repeatFaceVector)
{
	//first we check if nodeIndex originally has storage
	int i;
	root[nodeIndex].vMapSize=sizeof(PlyVertex)*(vertexVector.size()+repeatVertexVector.size());
	//either it is a new node or the old storage is too small
	if (root[nodeIndex].vStartPageIndex==-1||(root[nodeIndex].vStartPageIndex!=-1&&
		root[nodeIndex].vPageCount*PageSize<root[nodeIndex].vMapSize))
	{
		//we need to relocate at end of file, and lazy 
		root[nodeIndex].vPageCount=root[nodeIndex].vMapSize/PageSize +1;//lazy
	
		root[nodeIndex].vStartPageIndex=infoStruct.totalVPageCount;
		infoStruct.totalVPageCount+=root[nodeIndex].vPageCount;
		//now let's calculate the file pointer to store
		calculateFileOffsetV(root[nodeIndex].vStartPageIndex, 0, root[nodeIndex].vFileAddLow, 
			root[nodeIndex].vFileAddHigh);
		
	}
	//otherwise we could use the old file storage
	//otherwise we use the original file storage and file address
	setFilePointerV(nodeIndex, 0);

	GenericWriteFile(vertexHandle, &vertexVector[0], sizeof(PlyVertex)*vertexVector.size());

	GenericWriteFile(vertexHandle, &repeatVertexVector[0], sizeof(PlyVertex)*repeatVertexVector.size());


	//now let's write face into file
	root[nodeIndex].fMapSize=(faceVector.size()+repeatFaceVector.size())*sizeof(UIVector);

	if (root[nodeIndex].fStartPageIndex==-1||(root[nodeIndex].fStartPageIndex!=-1
		&&root[nodeIndex].fPageCount*PageSize<root[nodeIndex].fMapSize))
	{
		//we need to relocate at end of file
		root[nodeIndex].fPageCount=root[nodeIndex].fMapSize/PageSize + 1;

		root[nodeIndex].fStartPageIndex=infoStruct.totalFPageCount;
		infoStruct.totalFPageCount+=root[nodeIndex].fPageCount;
		//now let's calculate the file pointer to store
		calculateFileOffsetF(root[nodeIndex].fStartPageIndex, 0, root[nodeIndex].fFileAddLow, 
			root[nodeIndex].fFileAddHigh);
		
	}
	//otherwise we could use the old file storage
	//otherwise we use the original file storage and file address
	setFilePointerF(nodeIndex, 0);

	GenericWriteFile(faceHandle, &faceVector[0], sizeof(UIVector)*faceVector.size());

	GenericWriteFile(faceHandle, &repeatFaceVector[0], sizeof(UIVector)*repeatFaceVector.size());

	root[nodeIndex].vNumber=vertexVector.size();
	root[nodeIndex].vRepeatNumber=repeatVertexVector.size();
	root[nodeIndex].fNumber=faceVector.size();
	root[nodeIndex].fRepeatNumber=repeatFaceVector.size();
}
#else
void Octree::doCreateLeafNode(int nodeIndex, VertexVector& vertexVector, 
		VertexVector& repeatVertexVector, FaceVector& faceVector, FaceVector& repeatFaceVector)
{
	//first we check if nodeIndex originally has storage
	int i;


	root[nodeIndex].vMapSize=sizeof(PlyVertex)*(vertexVector.size()+repeatVertexVector.size());
	//either it is a new node or the old storage is too small
	if (root[nodeIndex].vStartPageIndex==-1||(root[nodeIndex].vStartPageIndex!=-1&&
		root[nodeIndex].vPageCount*PageSize<root[nodeIndex].vMapSize))
	{
		//we need to relocate at end of file, and lazy 
		root[nodeIndex].vPageCount=root[nodeIndex].vMapSize/PageSize +1;//lazy
	
		root[nodeIndex].vStartPageIndex=infoStruct.totalVPageCount;
		infoStruct.totalVPageCount+=root[nodeIndex].vPageCount;
		//now let's calculate the file pointer to store
		calculateFileOffsetV(root[nodeIndex].vStartPageIndex, 0, root[nodeIndex].vFileAddLow, 
			root[nodeIndex].vFileAddHigh);
		
	}
	//otherwise we could use the old file storage
	//otherwise we use the original file storage and file address
	setFilePointerV(nodeIndex, 0);
	for (i=0; i<vertexVector.size(); i++)
	{
		GenericWriteFile(vertexHandle, &vertexVector[i], sizeof(PlyVertex));
	}
	for (i=0; i<repeatVertexVector.size(); i++)
	{
		GenericWriteFile(vertexHandle, &repeatVertexVector[i], sizeof(PlyVertex));
	}

	//now let's write face into file
	root[nodeIndex].fMapSize=(faceVector.size()+repeatFaceVector.size())*sizeof(UIVector);

	if (root[nodeIndex].fStartPageIndex==-1||(root[nodeIndex].fStartPageIndex!=-1
		&&root[nodeIndex].fPageCount*PageSize<root[nodeIndex].fMapSize))
	{
		//we need to relocate at end of file
		root[nodeIndex].fPageCount=root[nodeIndex].fMapSize/PageSize + 1;

		root[nodeIndex].fStartPageIndex=infoStruct.totalFPageCount;
		infoStruct.totalFPageCount+=root[nodeIndex].fPageCount;
		//now let's calculate the file pointer to store
		calculateFileOffsetF(root[nodeIndex].fStartPageIndex, 0, root[nodeIndex].fFileAddLow, 
			root[nodeIndex].fFileAddHigh);
		
	}
	//otherwise we could use the old file storage
	//otherwise we use the original file storage and file address
	setFilePointerF(nodeIndex, 0);
	for (i=0; i<faceVector.size(); i++)
	{		
		GenericWriteFile(faceHandle, &faceVector[i], sizeof(UIVector));
	}
	for (i=0; i<repeatFaceVector.size(); i++)
	{	
		GenericWriteFile(faceHandle, &repeatFaceVector[i], sizeof(UIVector));

	}
	root[nodeIndex].vNumber=vertexVector.size();
	root[nodeIndex].vRepeatNumber=repeatVertexVector.size();
	root[nodeIndex].fNumber=faceVector.size();
	root[nodeIndex].fRepeatNumber=repeatFaceVector.size();
}
#endif


void Octree::expandRootNodeBounding(VVector coord, bool freeExpand)
{
	int i, oldSonIndex, newSonIndex, sonPos;
	VType temp;

	if (freeExpand)
	{
		for (i=0; i<3; i++)
		{
			temp=fabs((root[0].center[i]-coord[i])*2.0);
			if (root[0].width<temp)
			{
				root[0].width=temp+Epsilon;
			}
		}
	}
	else
	{
		while (true)
		{
			root[0].width=root[0].width*2.0;
			for (i=0; i<8; i++)
			{
				if (root[0].sons[i]!=-1)
				{
					//inserting a new son
					//remove old temporarily
					oldSonIndex=root[0].sons[i];
					root[0].sons[i]=-1;
					root[0].sonCount--;
					//create new
					newSonIndex=createNewOctreeNode(0, i);
					sonPos=relativePosition(root[oldSonIndex].center, root[newSonIndex].center);
					root[newSonIndex].sons[sonPos]=oldSonIndex;
					root[newSonIndex].sonCount++;
					root[oldSonIndex].parentIndex=newSonIndex;
				}
			}
			if (isCoordInsideBox(0, coord))
			{
				break;
			}
		}
	}
}

void outputFaceVector(char* fileName, FaceVector& faceVector)
{
	FILE* stream;
	stream=fopen(fileName, "w");
	for (int i=0; i<faceVector.size(); i++)
	{
		fprintf(stream, "no#%d: [%d, %d, %d]\n", i,  faceVector[i][0], faceVector[i][1], 
			faceVector[i][2]);
	}
	fclose(stream);
}

void outputVertexVector(char* fileName, VertexVector& vertexVector)
{
	FILE* stream;
	stream=fopen(fileName, "w");
	for (int i=0; i<vertexVector.size(); i++)
	{
		fprintf(stream, "no#%d: [%f, %f, %f]\n", i,  vertexVector[i].coord[0], 
			vertexVector[i].coord[1], vertexVector[i].coord[2]);
	}
	fclose(stream);
}

void outputRepeatTriangle(char* fileName, VertexVector& vertexVector, 
	VertexVector& repeatVertexVector, FaceVector& faceVector)
{
	FILE* stream;
	int index;
	stream=fopen(fileName, "w");
	for (int i=0; i<faceVector.size(); i++)
	{
		fprintf(stream, "no#%d triangle:\n", i);
		//printf("face[%d,%d,%d]\n", faceVector[i][0], faceVector[i][1], faceVector[i][2]);
		if (faceVector[i][2]>=vertexVector.size()+repeatVertexVector.size())
		{
			fprintf(stream, "the error is face%d out of bound\n", i);
			fprintf(stream, "face[%d,%d,%d]\n", faceVector[i][0], faceVector[i][1], 
				faceVector[i][2]);
		}
		for (int j=0; j<3; j++)
		{			
			//printf("[%f,%f,%f],", vertexVector[faceVector[i][j]].coord[0], 
			//vertexVector[faceVector[i][j]].coord[1], vertexVector[faceVector[i][j]].coord[2]);
			if (faceVector[i][j]>vertexVector.size())
			{
				index=faceVector[i][j]-vertexVector.size();
				fprintf(stream, "[%f,%f,%f],", repeatVertexVector[index].coord[0], 
				repeatVertexVector[index].coord[1], repeatVertexVector[index].coord[2]);
			}
			else
			{
				fprintf(stream, "[%f,%f,%f],", vertexVector[faceVector[i][j]].coord[0], 
				vertexVector[faceVector[i][j]].coord[1], vertexVector[faceVector[i][j]].coord[2]);
			}
		}
		//printf("\n");
		fprintf(stream, "\n");
	}
	fclose(stream);
}

void outputTriangle(char* fileName, VertexVector& vertexVector, FaceVector& faceVector)
{
	FILE* stream;
	stream=fopen(fileName, "w");
	for (int i=0; i<faceVector.size(); i++)
	{
		fprintf(stream, "no#%d triangle:\n", i);
		//printf("face[%d,%d,%d]\n", faceVector[i][0], faceVector[i][1], faceVector[i][2]);
		if (faceVector[i][2]>=vertexVector.size())
		{
			fprintf(stream, "the error is face%d out of bound\n", i);
			fprintf(stream, "face[%d,%d,%d]\n", faceVector[i].face[0], faceVector[i].face[1], 
				faceVector[i].face[2]);
		}
		fprintf(stream, "face[%d,%d,%d]\n", faceVector[i][0], 
				faceVector[i][1], faceVector[i][2]);
		for (int j=0; j<3; j++)
		{			
			//printf("[%f,%f,%f],", vertexVector[faceVector[i][j]].coord[0], 			
			fprintf(stream, "[%f,%f,%f],", vertexVector[faceVector[i][j]].coord[0], 
			vertexVector[faceVector[i][j]].coord[1], vertexVector[faceVector[i][j]].coord[2]);
		}
		//printf("\n");
		fprintf(stream, "\n");
	}
	fclose(stream);
}



void validateVertex(VertexVector& vertexVector, VertexVector sonVertexVector[8])
{
	int i, j, k;
	//////////////////////
	//testing
	bool bFound;
	for (i=0; i<8; i++)
	{
		for (j=0; j<sonVertexVector[i].size(); j++)
		{
			bFound=false;
			for (k=0; k<vertexVector.size(); k++)
			{
				if (equalCoord(sonVertexVector[i][j].coord, vertexVector[k].coord))
				{
					bFound=true;
					break;
				}
			}
			if (!bFound)
			{
				printf("data corrupted!!!\n");
				exit(89999);
			}
		}
	}
	/////////////////////////////////////////////
}


bool equalFace(VertexVector& firstVertexVector, FaceStruct& firstFace, 
				  VertexVector& secondVertexVector, FaceStruct& secondFace)
{
	int i, j;
	vector<int> pattern;
	bool findIt;

	findIt=true;
	for (i=0; i<3; i++)
	{
		pattern.push_back(secondFace[i]);
		if (!equalCoord(firstVertexVector[firstFace[i]].coord, 
				secondVertexVector[secondFace[i]].coord))
		{
			findIt=false;			
		}
	}
	if (findIt)
	{
		return true;
	}

	while (next_permutation(pattern.begin(), pattern.end()))
	{
		findIt=true;
		for (i=0; i<3; i++)
		{
			j=pattern[i];
			if (!equalCoord(firstVertexVector[firstFace[i]].coord, 
				secondVertexVector[j].coord))
			{
				findIt=false;
				break;
			}
		}
		if (findIt)
		{
			return true;
		}
	}
	return false;
}

bool findFace(VertexVector& targetVertex, FaceVector& targetFace, VertexVector& sourceVertex,
			  FaceStruct& faceStruct)
{
	for (int i=0; i<targetFace.size(); i++)
	{	
		if (equalFace(targetVertex, targetFace[i], sourceVertex, faceStruct))
		{
			return true;
		}
	}
	return false;
}

void compareVertex(char* fileName, VertexVector& sourceVertex, FaceVector& sourceFace, 
				   VertexVector& targetVertex, FaceVector& targetFace)
{
	//bool bFound;
	FILE* stream;
	stream=fopen(fileName, "w");

	for (int i=0; i<sourceFace.size(); i++)
	{
		if (!findFace(targetVertex, targetFace, sourceVertex, sourceFace[i]))
		{
			fprintf(stream, "cannot find this face:#%d\n", i);
			fprintf(stream, "face%d[%d,%d,%d]\n", i, sourceFace[i].face[0], 
				sourceFace[i].face[1], sourceFace[i].face[2]);
			
			fprintf(stream, "the three vertex are:\n");
			for (int j=0; j<3; j++)
			{
				fprintf(stream, "v[%f,%f,%f]\n", sourceVertex[sourceFace[i][j]].coord[0], 
				sourceVertex[sourceFace[i][j]].coord[1], sourceVertex[sourceFace[i][j]].coord[2]);
			}	
			fprintf(stream, "***************\n");
		}
	}
	fclose(stream);
}

void compareRepeatVertex(char* fileName, VertexVector& sonVertexVector,
	VertexVector& sonRepeatVertexVector, FaceVector& sonRepeatFaceVector, 
	VertexVector& vertexVector, FaceVector& faceVector)
{
	VertexVector sourceVertex;
	FaceStruct faceStruct;
	int i, j;
	FILE* stream;
	stream=fopen(fileName, "w");

	for (i=0; i<sonVertexVector.size(); i++)
	{
		sourceVertex.push_back(sonVertexVector[i]);
	}
	for (i=0; i<sonRepeatVertexVector.size(); i++)
	{
		sourceVertex.push_back(sonRepeatVertexVector[i]);
	}
	for (i=0; i<sonRepeatFaceVector.size(); i++)
	{
		for (j=0; j<3; j++)
		{
			faceStruct[j]=sonRepeatFaceVector[i][j];
		}
		if (!findFace(vertexVector, faceVector, sourceVertex, faceStruct))
		{
			fprintf(stream, "cannot find this face:#%d\n", i);
			fprintf(stream, "face%d[%d,%d,%d]\n", i, sonRepeatFaceVector[i][0], 
				sonRepeatFaceVector[i][1], sonRepeatFaceVector[i][2]);
			
			fprintf(stream, "the three vertex are:\n");
			for (int j=0; j<3; j++)
			{
				fprintf(stream, "v[%f,%f,%f]\n", sourceVertex[sonRepeatFaceVector[i][j]].coord[0], 
				sourceVertex[sonRepeatFaceVector[i][j]].coord[1], 
				sourceVertex[sonRepeatFaceVector[i][j]].coord[2]);
			}	
			fprintf(stream, "***************\n");
		}
	}
	fclose(stream);
}


void copyVector(VertexVector& source, VertexVector& target)
{
	target.assign(source.begin(), source.end());
}

void copyVector(FaceVector& source, FaceVector& target)
{
	target.assign(source.begin(), source.end());
}

void validateRepeat(char* fileName, VertexVector& vertexVector, FaceVector& faceVector)
{
	FILE* stream=fopen(fileName, "w");
	int i, j;
	bool findIt;
	for (i=0; i<faceVector.size(); i++)
	{
		findIt=false;
		for (j=0; j<faceVector.size(); j++)
		{
			if (i!=j)
			{
				if (equalFace(vertexVector, faceVector[i], vertexVector, faceVector[j]))
				{
					findIt=true;
					break;
				}
			}
		}
		if (!findIt)
		{
			fprintf(stream, "missing face%d[%d,%d,%d]\n", i, faceVector[i][0], 
				faceVector[i][1], faceVector[i][2]);
			for (j=0; j<3; j++)
			{
				fprintf(stream, "coord[%f,%f,%f]\n", vertexVector[faceVector[i][j]].coord[0],
					vertexVector[faceVector[i][j]].coord[1],
					vertexVector[faceVector[i][j]].coord[2]);
			}
		}
	}
	fclose(stream);
}


void compareTwoVertex(int nodeIndex, VertexVector& vertexVector, VertexVector& repeatVertexVector,
				FaceVector& faceVector, FaceVector& repeatFaceVector)
{
	char buf[32];
	VertexVector sourceVertex;
	int i;
	
	for (i=0; i<vertexVector.size(); i++)
	{
		sourceVertex.push_back(vertexVector[i]);
	}
	for (i=0; i<repeatVertexVector.size(); i++)
	{
		sourceVertex.push_back(repeatVertexVector[i]);
	}
	sprintf(buf, "CheckVertex%d.txt", nodeIndex);
	validateRepeat(buf, sourceVertex, faceVector);
	sprintf(buf, "CheckVertexRepeat%d.txt", nodeIndex);
	validateRepeat(buf, sourceVertex, repeatFaceVector);
}


void Octree::distributeVertex(int nodeIndex, HashTableNode* hashTable, VertexVector& vertexVector, 
					VertexVector& repeatVertexVector, VertexVector* sonVertexVector[8])
{
	bool needRestart;
	int counter;
	int i, j, sonPos, suggestOffset;


	counter=0;
	do
	{
		needRestart=false;
		counter++;
		for (i=0; i<vertexVector.size(); i++)
		{
			//later we can optimize it, but just leave it for safety checking.
			if (nodeIndex==0)
			{
				if (!isCoordInsideBox(nodeIndex, vertexVector[i].coord))
				{
					if (root[0].sonCount>0)
					{	
						//let's expand and insert and re-do everything from scratch
						
						expandRootNodeBounding(vertexVector[i].coord, false);

						//here we need to restart everything.
				
						for (j=0; j<8; j++)
						{
							sonVertexVector[j]->clear();
						}
						for (j=0; j<vertexVector.size()+repeatVertexVector.size(); j++)
						{
							hashTable[j].clear();
						}
						needRestart=true;
						break;					
					}
					else
					{
						//or we simply update the width of //simply
						expandRootNodeBounding(vertexVector[i].coord, true);
						//then we continue to insert
					}
				}
			}
		
			sonPos=relativePosition(vertexVector[i].coord, root[nodeIndex].center);
			
			suggestOffset=sonVertexVector[sonPos]->size();
			sonVertexVector[sonPos]->push_back(vertexVector[i]);			
			addVertexInfoToHashTable(hashTable, i, sonPos, suggestOffset);
		
		}
		if (counter%100==0)
		{
			printf("repeat in distributeVertex of %d in nodeIndex %d\n", counter, nodeIndex);
		}
	}
	while (needRestart);
	//now that we check the number of vertex to see if it exceeds limit
}



void Octree::doAddToOctreeNodePreparation(HashTableNode*& hashTable, int hashTableSize, VertexVector* sonVertexVector[8], 
		VertexVector* sonRepeatVertexVector[8], FaceVector* sonFaceVector[8], FaceVector* sonRepeatFaceVector[8])
{

	hashTable=new HashTableNode[hashTableSize];

	CHECK_NEW(hashTable);
	for (int i=0; i<8; i++)
	{
		sonVertexVector[i]= new VertexVector;
		CHECK_NEW(sonVertexVector[i]);
		sonRepeatVertexVector[i]=new VertexVector;
		CHECK_NEW(sonRepeatVertexVector[i]);
		sonFaceVector[i]=new FaceVector;
		CHECK_NEW(sonFaceVector[i]);
		sonRepeatFaceVector[i]=new FaceVector;
		CHECK_NEW(sonRepeatFaceVector[i]);		
	}
}


//this function must be "static" because possible expansion happens...?? not really expansion
void Octree::doAddToOctree(int nodeIndex, VertexVector& vertexVector, 
	VertexVector& repeatVertexVector, FaceVector& faceVector, FaceVector& repeatFaceVector)
{
	int i, j;
	int vNumberCounter=0, vRepeatCounter=0, fNumberCounter=0, fRepeatCounter=0;
	VertexVector* sonVertexVector[8];
	VertexVector* sonRepeatVertexVector[8];
	FaceVector* sonFaceVector[8];
	FaceVector* sonRepeatFaceVector[8];
	//bool needRestart;
	int insertVertexCount, insertRepeatVertexCount;
	HashTableNode* hashTable;
	HANDLE tempVertexFileHandle;
	HANDLE tempFaceFileHandle;	
	char tempVertexFileName[MAX_PATH];
	char tempFaceFileName[MAX_PATH];

	int vertexCount, repeatVertexCount, faceCount, repeatFaceCount;

	//added by nick Apr.7, 2008, we don't need repeatVertex here.
	repeatVertexVector.clear();
	repeatFaceVector.clear();
	//added finish

	if (root[nodeIndex].sonCount==0 )
	{
		//read in all vertex from file	
		insertVertexCount=vertexVector.size();
		insertRepeatVertexCount=repeatVertexVector.size();
		if (root[nodeIndex].vNumber>0||root[nodeIndex].vRepeatNumber>0)
		{
			readOriginalVertex(nodeIndex, vertexVector, repeatVertexVector, repeatFaceVector);
		}
		//assuming sorting and updating the "repeat-face-index"
		if (root[nodeIndex].fNumber>0||root[nodeIndex].fRepeatNumber>0)
		{
			readOriginalFace(nodeIndex, faceVector, repeatFaceVector, insertVertexCount, 
				insertRepeatVertexCount);		
		}
	}

	//compareVertex(oldVertex, oldFace, vertexVector, faceVector);
	//compareVertex( vertexVector, faceVector, oldVertex, oldFace);


	//no need for "prelocated"
	//added by nick on "feb. 23, 2008"
	//if (vertexVector.size()<infoStruct.maxLeafNodeVertexNumber)
	if (vertexVector.size()<infoStruct.maxLeafNodeVertexNumber||repeatVertexVector.size()>=infoStruct.maxLeafNodeVertexNumber)
	{
		//create leaf node and return
		//compareTwoVertex(nodeIndex, vertexVector, repeatVertexVector, faceVector,
		//	repeatFaceVector);
		////////////////////////////////
		doCreateLeafNode(nodeIndex, vertexVector, repeatVertexVector, faceVector,
			repeatFaceVector);
	
		return;
	}

	doAddToOctreeNodePreparation(hashTable, vertexVector.size()+repeatVertexVector.size(), sonVertexVector,
		sonRepeatVertexVector, sonFaceVector, sonRepeatFaceVector);

	distributeVertex(nodeIndex, hashTable, vertexVector, repeatVertexVector, sonVertexVector);

	//////////////////////////////////
	//testing
	//for (i=0; i<8; i++)
	//{
	//	compareVertex(sonVertexVector[i], sonFaceVector[i], vertexVector, faceVector);		
	//}

	/*
	if (nodeIndex==0)
	{
		outputVertexVector("beforeVertex.txt", vertexVector);
		outputVertexVector("beforerepeatvertex.txt", repeatVertexVector);
		outputFaceVector("beforeface.txt", faceVector);
		outputFaceVector("beforerepeatface.txt", repeatFaceVector);
		outputTriangle("beforetriangle.txt", vertexVector, faceVector);
	}
	*/


	////////////////////////////
	//now let's handle the face update
	for (i=0; i<faceVector.size(); i++)
	{	
		//printf("faceVector.size()=%d\n", faceVector.size());
		//printf("triangle%d[%d,%d,%d]\n",i, faceVector[i].face[0],
		//	faceVector[i].face[1], faceVector[i].face[2]);
		addFaceToSonFaceVector(hashTable, faceVector[i], vertexVector, repeatVertexVector, 
			sonVertexVector, sonRepeatVertexVector, sonFaceVector, sonRepeatFaceVector);			
	}



	for (i=0; i<repeatFaceVector.size(); i++)
	{	
		//printf("repeatfaceVector.size()=%d\n", repeatFaceVector.size());
		//printf("triangle%d[%d,%d,%d]\n",i, repeatFaceVector[i].face[0],
		//	repeatFaceVector[i].face[1], repeatFaceVector[i].face[2]);
		/////////////////	
		addFaceToSonFaceVector(hashTable, repeatFaceVector[i], vertexVector, repeatVertexVector, 
			sonVertexVector, sonRepeatVertexVector, sonFaceVector, sonRepeatFaceVector);
	}

	//before recursion, let's release memory
	delete[]hashTable;

	for (i=0; i<8; i++)
	{				
		int sonNodeIndex;
		if (sonVertexVector[i]->size()>0)
		{
			/////////////////////////////////////////////
			sonNodeIndex=createNewOctreeNode(nodeIndex, i);	

#ifdef USING_QUICK_RECURSION		

			doAddToOctree(sonNodeIndex, *sonVertexVector[i], *sonRepeatVertexVector[i], 
				*sonFaceVector[i], *sonRepeatFaceVector[i]);	
		}
		delete sonVertexVector[i];
		delete sonRepeatVertexVector[i];
		delete sonFaceVector[i];
		delete sonRepeatFaceVector[i];
		

#else
			/////////////////////////////////////////////////	
			tempVertexFileHandle=GenericOpenTempFile("vertex", tempVertexFileName);
			tempFaceFileHandle=GenericOpenTempFile("face", tempFaceFileName);



			vertexCount=sonVertexVector[i]->size();
			repeatVertexCount=sonRepeatVertexVector[i]->size();
			faceCount=sonFaceVector[i]->size();
			repeatFaceCount=sonRepeatFaceVector[i]->size();

			for (j=0; j<vertexCount; j++)
			{
				GenericWriteFile(tempVertexFileHandle, &(sonVertexVector[i]->at(j)), sizeof(PlyVertex));
			}
			for (j=0; j<repeatVertexCount; j++)
			{
				GenericWriteFile(tempVertexFileHandle, &(sonRepeatVertexVector[i]->at(j)), sizeof(PlyVertex));
			}
			for (j=0; j<faceCount; j++)
			{
				GenericWriteFile(tempFaceFileHandle, sonFaceVector[i]->at(j).face, sizeof(FaceStruct));
			}
			for (j=0; j<repeatFaceCount; j++)
			{
				GenericWriteFile(tempFaceFileHandle, sonRepeatFaceVector[i]->at(j).face, sizeof(FaceStruct));
			}

			//I would rather delete it before recursion
			delete sonVertexVector[i];
			delete sonRepeatVertexVector[i];
			delete sonFaceVector[i];
			delete sonRepeatFaceVector[i];

			doAddToOctreeWrapper(sonNodeIndex, vertexCount, repeatVertexCount, faceCount, repeatFaceCount, 
				tempVertexFileHandle, tempFaceFileHandle);

			GenericCloseTempFile(tempVertexFileHandle, tempVertexFileName);
			GenericCloseTempFile(tempFaceFileHandle, tempFaceFileName);


			//doAddToOctree(sonNodeIndex, *sonVertexVector[i], *sonRepeatVertexVector[i], 
			//	*sonFaceVector[i], *sonRepeatFaceVector[i]);	
			//////////////////////////////////
	
				
			//here is just counting, we don't move file pointers
			//after this recursion, the temp file will not be used any more
		}
		else
		{
			delete sonVertexVector[i];
			delete sonRepeatVertexVector[i];
			delete sonFaceVector[i];
			delete sonRepeatFaceVector[i];
		}
#endif
		if (root[nodeIndex].sons[i]!=-1)
		{
			sonNodeIndex=root[nodeIndex].sons[i];
			vNumberCounter+=root[sonNodeIndex].vNumber;
			vRepeatCounter+=root[sonNodeIndex].vRepeatNumber;
			fNumberCounter+=root[sonNodeIndex].fNumber;
			fRepeatCounter+=root[sonNodeIndex].fRepeatNumber;
		}
	}	
	
	root[nodeIndex].vNumber=vNumberCounter;
	root[nodeIndex].vRepeatNumber=vRepeatCounter;
	root[nodeIndex].fNumber=fNumberCounter;
	root[nodeIndex].fRepeatNumber=fRepeatCounter;
}


void Octree::doAddToOctreeWrapper(int nodeIndex, int vertexCount, int repeatVertexCount, int faceCount, 
		int repeatFaceCount, HANDLE vertexHandle, HANDLE faceHandle)
{
	int i;
	//unsigned long length;
	PlyVertex plyVertex;
	FaceStruct faceStruct;
	VertexVector* vertexVector;
	VertexVector* repeatVertexVector;
	FaceVector* faceVector;
	FaceVector* repeatFaceVector;


	vertexVector=new VertexVector;
	CHECK_NEW(vertexVector);
	repeatVertexVector=new VertexVector;
	CHECK_NEW(repeatVertexVector);
	faceVector=new FaceVector;
	CHECK_NEW(faceVector);
	repeatFaceVector=new FaceVector;
	CHECK_NEW(repeatFaceVector);

	//SetFilePointer(vertexHandle, 0, NULL, FILE_BEGIN);
	GenericSetFilePointer(vertexHandle, 0, 0);

	for (i=0; i<vertexCount; i++)
	{
		GenericReadFile(vertexHandle, &plyVertex, sizeof(PlyVertex));
		//WINAPI_CALL(ReadFile(vertexHandle, &plyVertex, sizeof(PlyVertex), &length, NULL), "read vertex file");
		
		vertexVector->push_back(plyVertex);
	}
	for (i=0; i<repeatVertexCount; i++)
	{
		GenericReadFile(vertexHandle, &plyVertex, sizeof(PlyVertex));
		//WINAPI_CALL(ReadFile(vertexHandle, &plyVertex, sizeof(PlyVertex), &length, NULL), "read repeat vertex");
		repeatVertexVector->push_back(plyVertex);
	}

	//SetFilePointer(faceHandle, 0, NULL, FILE_BEGIN);
	GenericSetFilePointer(faceHandle, 0, 0);

	for (i=0; i<faceCount; i++)
	{
		GenericReadFile(faceHandle, faceStruct.face, sizeof(FaceStruct));		
		//WINAPI_CALL(ReadFile(faceHandle, faceStruct.face, sizeof(FaceStruct), &length, NULL), "read face");
		faceVector->push_back(faceStruct);
	}

	for (i=0; i<repeatFaceCount; i++)
	{
		GenericReadFile(faceHandle, faceStruct.face, sizeof(FaceStruct));
		//WINAPI_CALL(ReadFile(faceHandle, faceStruct.face, sizeof(FaceStruct), &length, NULL), "read repeat face");
		repeatFaceVector->push_back(faceStruct);
	}


	doAddToOctree(nodeIndex, *vertexVector, *repeatVertexVector, *faceVector, *repeatFaceVector);

	delete vertexVector;
	delete repeatVertexVector;
	delete faceVector;
	delete repeatFaceVector;
}




void Octree::readDataFromFile(HANDLE inVertexHandle, VertexVector& vertexVector)
{
	PlyVertex plyVertex;
	//unsigned long length;
	int length;
	GenericSetFilePointer(inVertexHandle, 0, 0);
	do
	{
		//WINAPI_CALL(ReadFile(inVertexHandle, &plyVertex, sizeof(PlyVertex), &length, NULL), "read vertex file");
		length=GenericReadFile(inVertexHandle, &plyVertex, sizeof(PlyVertex));
		if (length==0)
		{
			break;
		}
		else
		{
			assert(length==sizeof(PlyVertex));		
		}
		vertexVector.push_back(plyVertex);
	}
	while (true);

	if (vertexVector.size()==0)
	{
		printf("empty file error\n");
	}
	
}

void Octree::readDataFromFile(HANDLE inFaceHandle, FaceVector& faceVector)
{
	FaceStruct triangle;
	//unsigned long length;
	int length;
	GenericSetFilePointer(inFaceHandle, 0, 0);
	do
	{
		//WINAPI_CALL(ReadFile(inFaceHandle, &triangle, sizeof(FaceStruct), &length, NULL), "read vertex file");
		length=GenericReadFile(inFaceHandle, &triangle, sizeof(FaceStruct));
		
		if (length==0)
		{
			break;
		}
		else
		{
			assert(length==sizeof(FaceStruct));		
		}
		/////////////////////////////////////
		faceVector.push_back(triangle);
	}
	while (true);
	//error here
	assert(faceVector.size()!=0);
}

void Octree::addToOctree(VertexVector& inVertexVector, FaceVector& inFaceVector)
{
	int i;
	VertexVector repeatVertexVector;
	FaceVector repeatFaceVector;
	if (infoStruct.nodeCount==0)
	{
		//create from scratch
		//to do
		initOctreeNode(0);
		root[0].level=0;
		infoStruct.nodeCount=1;
		memcpy(root[0].center, inVertexVector[0].coord, sizeof(VVector));
		memcpy(infoStruct.origin, root[0].center, sizeof(VVector));
		root[0].width=MinOctreeNodeWidth;
		infoStruct.maxX=infoStruct.minX=inVertexVector[0].coord[0];
		infoStruct.maxZ=infoStruct.minZ=inVertexVector[0].coord[2];
		//create octree array and initialize
	}
	//here let's calculate the max-edge
	for (i=0; i<inFaceVector.size(); i++)
	{
		calculateEdges(inFaceVector[i], inVertexVector);
	}

	for (i=0; i<inVertexVector.size(); i++)
	{
		if (inVertexVector[i].coord[0]>infoStruct.maxX)
		{
			infoStruct.maxX=inVertexVector[i].coord[0];
		}
		if (inVertexVector[i].coord[0]<infoStruct.minX)
		{
			infoStruct.minX=inVertexVector[i].coord[0];
		}

		if (inVertexVector[i].coord[2]>infoStruct.maxZ)
		{
			infoStruct.maxZ=inVertexVector[i].coord[2];
		}
		if (inVertexVector[i].coord[2]<infoStruct.minZ)
		{
			infoStruct.minZ=inVertexVector[i].coord[2];
		}
	}


	doAddToOctree(0, inVertexVector, repeatVertexVector, inFaceVector, repeatFaceVector);
	calculateNeighbour();

}

void Octree::addToOctree(char* inVertexFileName, char* inFaceFileName)
{
	VertexVector vertexVector;
	FaceVector faceVector;
	HANDLE inVertexHandle, inFaceHandle;
	//to do

	/*
	inVertexHandle=CreateFile(inVertexFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL , NULL);
	inFaceHandle=CreateFile(inFaceFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL , NULL);
	if (inVertexHandle==INVALID_HANDLE_VALUE||inFaceHandle==INVALID_HANDLE_VALUE)
	{
		printf("cannot create output vertex file\n");
		exit(9);
	}
	*/

	inVertexHandle=GenericOpenFile(inVertexFileName, true);
	inFaceHandle=GenericOpenFile(inFaceFileName, true);



	//open file handle
	readDataFromFile(inVertexHandle, vertexVector);
	readDataFromFile(inFaceHandle, faceVector);

	addToOctree(vertexVector, faceVector);
	
	

	/*
	CloseHandle(inVertexHandle);
	CloseHandle(inFaceHandle);
	*/
	GenericCloseFile(inVertexHandle);
	GenericCloseFile(inFaceHandle);

}


VType Octree::calcEdge(VVector v1, VVector v2)
{
	VType result=0;
	for (int i=0; i<3; i++)
	{
		result+=(v1[i]-v2[i])*(v1[i]-v2[i]);
	}
	return sqrt(result);
}

void Octree::calculateEdges(FaceStruct& tri, VertexVector& vertexVector)
{
	VType result;
	//float edge[3];
	//int first, second;
	for (int i=0; i<3; i++)
	{		
		result=calcEdge(vertexVector[tri[i]].coord, vertexVector[tri[(i+1)%3]].coord);
		if (result==0)
		{
			printf("data corrupted! edge cannot be 0 %d,%d,%d\n", tri.face[0], tri.face[1], tri.face[2]);
			for (int j=0; j<3; j++)
			{
				printf("[%d]%f, [%d]%f\n", j, vertexVector[tri[i]].coord[j], j, vertexVector[tri[(i+1)%3]].coord[j]);
			}
			//exit(890);
		}

		if (infoStruct.maxEdge==0||infoStruct.maxEdge<result)
		{
			infoStruct.maxEdge=result;
		}
		if (infoStruct.minEdge==0||infoStruct.minEdge>result)
		{
			infoStruct.minEdge=result;
		}
	}
}

void Octree::sortTriangle(FaceStruct& triangle)
{
	sortTriangleIndex(triangle.face);
}
