
octreeTool.exe: frustum.obj octree.obj octreeLoader.obj octreeTool.obj plyConverter.obj renderEngine.obj rply.obj \
        viewCollector.obj syscallLinux.obj octreeTool.cpp
	@echo "compiling octreeTool.exe..."
	g++ -g -fstack-protector-all -lGL -lGLU -lglut frustum.obj octree.obj octreeLoader.obj octreeTool.obj  plyConverter.obj \
        renderEngine.obj rply.obj viewCollector.obj syscallLinux.obj -o ./bin/octreeTool.exe
	rm -f *.obj
syscallLinux.obj: syscall.h syscallLinux.cpp
	@echo "syscallLinux.obj"
	g++ -g -c syscallLinux.cpp -o syscallLinux.obj

frustum.obj: frustum.cpp frustum.h config.h
	@echo "frustum.obj..."
	g++ -g -c frustum.cpp -o frustum.obj
octree.obj: octree.h octree.cpp syscallLinux.obj
	@echo "octree.obj..."
	g++ -g -c octree.cpp -o octree.obj
plyConverter.obj: plyModel.h plyConverter.cpp rply.h syscallLinux.obj 
	@echo "plyConverter.obj..."
	g++ -c plyConverter.cpp  -o plyConverter.obj
rply.obj: rply.c rply.h
	@echo "rply.obj..."
	gcc -g -c rply.c -o rply.obj
octreeLoader.obj: octreeLoader.cpp octreeLoader.h frustum.obj
	@echo "octreeLoader.obj ..."
	g++ -g -c octreeLoader.cpp -o octreeLoader.obj

viewCollector.obj: viewCollector.h viewCollector.cpp octreeLoader.obj octreeLoader.h syscallLinux.obj
	@echo "viewCollector.obj..."
	g++ -g -c viewCollector.cpp  -o viewCollector.obj
octreeTool.obj: octreeTool.cpp 
	g++ -g -c octreeTool.cpp -o octreeTool.obj

renderEngine.obj: renderEngine.cpp renderEngine.h 
	g++ -g -c renderEngine.cpp -o renderEngine.obj





	
